<template>
<div class="home">
<Dialog/>
<Alert/>
    <div class="card-header p-2">
      <h3> These are Our Shares </h3>
    </div>

    <table border="0">
    <tr v-for="post in postingans" :key="post.id" :post="post">
      <v-list>
        <v-list-item>
        <v-list-item-avatar>
          <v-img :src="'https://dummyimage.com/16:9x780'"></v-img>
        </v-list-item-avatar>
        <v-list-item-content>
          <v-list-item-title><small><b>@{{post.user_name}}</b> || Shared at {{ post.created_at }}</small></v-list-item-title>
        </v-list-item-content>
        
        </v-list-item>
      </v-list>
      <b> {{post.caption}} </b><br>
      <v-img width="200" :src="post.gambar ? `${apiDomain}/gambar/${post.gambar}` : 'https://picsum.photos/200/300'"></v-img>
      <small>{{ post.tulisan }}</small><br>
      <small>{{ post.qoute }}</small><br>
          
          <v-btn small text @click="like(post.id)" class="blue--text">
          <v-icon>mdi-heart-multiple-outline</v-icon>  {{post.count_like}} Like
          </v-btn>
          
           <v-btn small text @click="comment(post.id)" class="blue--text">
          <v-icon>mdi-comment-quote-outline</v-icon>  {{post.count_komentars}} comment this
          </v-btn>
          <br><br>
   
    <h4 style="color:blue">Komentar:</h4>
    <div v-for="komen in post.komentars" :key="komen.id" :komen="komen">
      <small><b>@{{komen.user_name}}</b></small><br>
      <p>{{komen.komentar}}</p>
      <v-btn small text @click="likecomment(komen.id)" class="blue--text">
      <v-icon>mdi-heart-multiple-outline</v-icon>  {{komen.count_like}} like this comment
      </v-btn>
      <br><br>
    </div>
    <hr>
    </tr>
    </table>
          
</div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';


export default {
    data : () => ({
      postingans : [],
      apiDomain : "http://127.0.0.1:8000",
    }),

    computed: {
    ...mapGetters({
      user : 'auth/user',
      token : 'auth/token'
    }),
  },

   components : {
     Alert : () => import ('../components/Alert.vue'),
     Dialog : () => import ('../components/Dialog.vue')
    },

    props : ['post', 'komen'],

    methods : {
     ...mapActions({
        setpostId : 'post/setpostId',
        setDialogComponent : 'dialog/setComponent',
        setAlert  : 'alert/set',
      }),

      like: function(postId){
        console.log(this.token)
        const config = {
          method: 'post',
          url: this.apiDomain + "/api/postinganlikes",
          headers: {
          'Authorization' : 'Bearer ' + this.token,
        },
          data: {
          'postingan_id' : postId,
          'token' : this.token
          }
        }
        this.axios(config)
          .then((response) => {
            this.getPosts()
            console.log(response)
            this.setAlert({
                    status : true,
                    color  : 'success',
                    text  : 'You liked this post',
                })
          })
          .catch((error) => {
            console.log(error)
          })
      },

      likecomment: function(komenId){
        console.log(komenId)
        const config = {
          method: 'post',
          url: this.apiDomain + "/api/komentarlikes",
          headers: {
          'Authorization' : 'Bearer ' + this.token,
        },
          data: {
          'komentar_id' : komenId,
          'token' : this.token
          }
        }
        this.axios(config)
          .then((response) => {
            this.getPosts()
            console.log(response)
            this.setAlert({
                    status : true,
                    color  : 'success',
                    text  : 'You liked this comment',
                })
          })
          .catch((error) => {
            console.log(error)
          })
      },

      comment(postId){
        this.setDialogComponent({'component' : 'commentadd'})
        this.setpostId(postId)
        this.getPosts()
      },

      getPosts: function () {
          const config = {
              method: "get",
              url: this.apiDomain + "/api/postingans",
          }

          this.axios(config)
              .then((response) => {
                  this.postingans = response.data.data
                  
                  console.log(response.data.data)
              })
              .catch((error) => {
                  console.log(error)
              })
      },
    },
    created(){
      this.getPosts();
    }
}
</script>
